(* This file is part of MLGame (OCaml Game System).

   MLGame is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 2 of the License, or (at your option) any later
   version.

   MLGame is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with MLGame; if not, write to the Free Software Foundation, Inc., 59 Temple
   Place, Suite 330, Boston, MA 02111-1307 USA *)

(** Module with simple key translations *)

(** Exception raised when the given keyname is not known *)
exception Unknown;;

(** Translates a key name to the key type. The bool argument 
   is true if the user means a press of the key, and false
   if the string is for example "-tab" *)
val key_of_string : string -> Sdlkey.t * bool;;

(** Returns the char with shift translation that is
   capitalized letter or for example exclamation mark
   in place of '1' *)
val shifted_char : char -> char;;
