
(** Handles all available weapons *)

(** Weapon name and constructor. *)
type weapon = string * (Bullet.set -> Player.t Weapon.t);;

(** List of all available weapons. *)
val list : weapon list;;

(** @return a list of given number of randomly choosen weapons (without
    duplicates). If you require more weapons that there are, all available
    weapons will be returned. *)
val get_random_list : int -> weapon list;;

(** @return a randomly choosed weapon. *)
val get_random : unit -> weapon;;

