
type unknown = unit;;

type t = unknown Sprite.set * (int * int * int * int);;

let stone_img = Video.optimize (Video.color_key (Video.load_image "Data/stone_big-t.png"));;

let create () = 
  let boundary = (0, 0, 800, 600) in
  let set = Sprite.Set.create 64 in
  Sprite.Set.set_collision set 64 64;
  for i = 1 to 30 do
    let new_stone = (*Video.duplicate_surface*) stone_img in
    let _, _, x1, y1 = boundary in
    ignore (Sprite.create ~set:set () new_stone (Random.int x1, Random.int y1))
  done;
  set, boundary
;;

let get_boundary (_, boundary) = boundary;;

let get_sprite_set (set, _) = set;;

let draw (set, _) on =
  Sprite.Set.iter (Sprite.draw ~on) set
;;

let set_boundary (_, (x0, y0, x1, y1)) set = 
  Sprite.Set.set_boundary set x0 y0 x1 y1
;;

let set_cam_pos_center (_, (x0, y0, x1, y1)) cntx (x, y) = 
  let sx, sy = cntx.Video.rect.Sdlvideo.r_w, cntx.Video.rect.Sdlvideo.r_h in
  let x, y = x-sx/2, y-sy/2 in
  let x = max x0 (min (x1-sx) x) in
  let y = max y0 (min (y1-sy) y) in
  Video.set_cam_pos ~on:cntx (x, y)
;;

let delay = ref 0.02;;
