
(** The arena *)

(** The arena. *)
type t;;

(** Create the arena. *)
val create : unit -> t;;

type unknown;;

(** @return the arena as sprite set. *)
val get_sprite_set : t -> unknown Sprite.set;;

(** Draws the arena on context. *)
val draw : t -> Video.t -> unit;;

(** Sets the boundary of the argument to the arena size. *)
val set_boundary : t -> 'a Sprite.set -> unit;;

(** @return the boundary of the arena. *)
val get_boundary : t -> int * int * int * int;;

(** [set_cam_pos_center arena context (x, y)] sets coordinates of world
    displayed, so that [(x, y)] will be as near the center as possible, but
    in such way, that the arena will cover the whole screen. *)
val set_cam_pos_center : t -> Video.t -> Types.pos -> unit;;

(** Real delay between the frames. Set by main.ml. *)
val delay : float ref;;
