
let create_set arena players = Hashtbl.create 100, arena, players;;

let rec find_min_free hashtbl i =
  if (Hashtbl.mem hashtbl i) then find_min_free hashtbl (i + 1) else i
;;

class virtual t (bullets, arena, players) = object (self)
  method virtual process : unit
  method virtual draw : Video.t -> unit
  val no = find_min_free bullets 0
  initializer Hashtbl.add bullets no (self :> t)
  method delete = Hashtbl.remove bullets no
  val players : Player.set = players
  val arena : Arena.t = arena
end;;

type set = (int, t) Hashtbl.t * Arena.t * Player.set;;

let iter f (bullets, _, _) = Hashtbl.iter (fun _ -> f) bullets
