

type state = {
  mutable angle : float;
}

type t = state Sprite.t;;

let img = Video.load_image "Data/krzyzyk.png";;

let create () = Sprite.create ~center_pos:(2,2) { angle = 0. } img (0, 0);;

let get_angle cr = (Sprite.get_data cr).angle;;

let process sprite pl_no dir (pos_x, pos_y) =
  let data = Sprite.get_data sprite in
  let angle = data.angle +. 
    (float_of_int (Controls.get_vy pl_no)) *. !Arena.delay *. !Constants.aim_speed 
  in
  let angle = min Constants.aim_angle_max (max Constants.aim_angle_min angle)
  in data.angle <- angle;
  Sprite.move_to sprite
    (pos_x + (Types.dir_to_int dir) * int_of_float (Constants.crosshair_dist *. cos angle),
     pos_y + int_of_float (Constants.crosshair_dist *. sin angle))
;;

let get_pos = Sprite.get_pos;;

let draw cr cntx = Sprite.draw ~on:cntx cr;;

