
(** Crosshair (sight) *)

(** Crosshair (sight). *)
type t;;

(** Create new crosshair. *)
val create : unit -> t;;

(** Get angle in which we are looking. Lower values means higher. Up is -pi,
    down is +pi. *)
val get_angle : t -> Types.angle;;

(**  Called when it's time for new frame.

     Call [process ch pl_no dir pos]  for crosshair [ch] of player number
     [pl_no] looking in direction [dir] and staying at position [pos]. *)
val process : t -> int -> Types.dir -> Types.pos -> unit;;

(** @return the crosshair position. *)
val get_pos : t -> Types.pos;;

(** Called when there is a need to draw the object on a context. *)
val draw : t -> Video.t -> unit;;

