

type desc = {
  img : Video.t;
  no_frames : int;
  pos : Types.pos;
  force : int;
  owner : Player.t option;
};;

let std_desc = {
  no_frames = 16;
  img = Video.load_image "Data/explosion.png";
  pos = 0, 0;
  force = 55;
  owner = None;
};;

class t set desc = object (self)
  inherit Bullet.t set

  val sprite = 
    let w, h = desc.img.Video.rect.Sdlvideo.r_w, desc.img.Video.rect.Sdlvideo.r_h in
    let w = w / desc.no_frames in
    Sprite.create ~width:w ~center_pos:(w / 2, h / 2) () desc.img desc.pos
    
  initializer 
    Sprite.set_animation_frame sprite (desc.no_frames - 1);
    let list = Player.collides_with players sprite in
    List.iter (fun x -> Player.injure x desc.force desc.owner) list;

  method process = 
    let frame = Sprite.get_animation_frame sprite in
      if frame > 1 then 
        Sprite.set_animation_frame sprite (frame - 1)
      else
        (* no need to delete the sprite -> it's not in any set *)
        self#delete

  method draw cntx = Sprite.draw ~on:cntx sprite
end;;

