
(** Explosion *)

(** Description of an explosion. *)
type desc = {
  img : Video.t; (** image of the explosion *)
  no_frames : int; (** number of frames in the image *)
  pos : Types.pos; (** posiotion of the center of the explosion *)
  force : int; (** force of the explosion (number of life points taken) *)
  owner : Player.t option; (** the player who caused the explosion (or none) *)
};;

(** Typical explosion description. *)
val std_desc : desc;;

(** Explosion. *)
class t : Bullet.set -> desc -> object
  inherit Bullet.t
  
  (** Called when it's time for new frame. Changes how the explosion look
      like in time, finally removes it. *)
  method process : unit

  (** Called when there is a need to draw the object on a context. Draws the
      explosion. *)
  method draw : Video.t -> unit
end;;
