
(** The rope with the hook *)

(** The rope with the hook. *)
type t;;

(** Create new rope. Call once when creating new player. Takes the arena on
    which everything happens. *)
val create : Arena.t -> t;;

(** Release (throw) a rope. Call [release hook pos vel] for throwing rope
    [hook] from point [pos] with initial velocity [vel]. *)
val release : t -> Types.pos -> Types.vel -> unit;;

(** Call when there is a need to draw the object on a context. 

    [draw context hook player_pos] draws on [context] the rope [hook] from
    player staying in [player_pos]. *) 
val draw : Video.t -> t -> Types.pos -> unit;;

(** [rope_force hook pos] @return the force with which the rope [hook]
    influence on the player staying on position [pos]. *)
val rope_force : t -> Types.pos -> Types.force;;

(** Called when it's time for new frame. Move the end of the rope if it is
    not already hooked. *)
val process : t -> unit;;

(** Hide the rope. *)
val hide : t -> unit;;
