
let to_int (x, y) = (int_of_float x, int_of_float y);;

let pixel = Video.load_image "Data/pixel.png";;

let step = 3.;;
let force = 100.;;


class ray set params check_stop_fun = object (self)
  inherit Bullet.t set

  val mutable pos = 0, 0
  val mutable pos2 = 0, 0

  (* only for testing collisions *)
  val sprite = Sprite.create () pixel (0, 0)

  initializer 
    let set = Sprite.Set.create 1 in
    Arena.set_boundary arena set;
    Sprite.Set.add set sprite;
    self#calculate false

  method calculate can_injure =
    let player = match params.Weapon.player with Some pl -> pl | _ -> assert false in
    let angle = Player.get_angle player in
    pos <- Player.get_pos player;
    let x0, y0 = pos in
    let dir = Types.dir_to_int (Player.get_direction player) in
    let xd = step *. float_of_int dir *. cos angle in
    let yd = step *. sin angle in
    let rec check x y =
      (* check if in this possition there is no player or rock *)
      Sprite.move_to sprite (to_int (x, y));
      let pls = Player.collides_with players sprite in
      let pls = List.filter (fun pl -> pl != player) pls in
      let ar = Sprite.collides_with sprite true (Arena.get_sprite_set arena) in
      List.iter (fun pl -> 
          Player.injure pl (int_of_float (force *. !Arena.delay)) (Some player)
        ) pls;
      if pls = [] && ar = [] && Sprite.in_bounds sprite then
        check (x +. xd) (y +. yd)
      else
        x, y
    in
    pos2 <- to_int (check (float_of_int x0) (float_of_int y0))

  method process = 
    if check_stop_fun () then self#delete
    else self#calculate true 
  
  method draw cntx = 
    let color = (255, 0, 0) in
    Video.line ~on:cntx pos pos2 color
end;;

let fire set params check_stop_fun = ignore (new ray set params check_stop_fun);;

let create set = Weapon.create_cont (fire set) 1.5 1. "LASER";;

