
let frame = ref 0.;;

let process () = 
  frame := !frame +. !Arena.delay;
  let bl_t = Constants.status_blinking_time in
  while !frame > 2. *. bl_t do frame := !frame -. 2. *. bl_t done
;;

let font_white = Font.load "Data/font.png"
let font_red = Font.load "Data/font1.png"
let font_green = Font.load "Data/font2.png"

let draw pl cntx = 
  let status = Player.get_status pl in
  let sx = cntx.Video.rect.Sdlvideo.r_w in
  let x0 = Constants.status_margin_x in 
  let x1 = sx - x0 in
  let h_len = status.Player.health100 * (x1 - x0) / 100 in
  Video.fill ~on:cntx 
    ~rect:(Sdlvideo.rect x0 Constants.status_health_y h_len Constants.status_bar_height) 
    Constants.status_health_color;
  let a_len = status.Player.ammo100 * (x1 - x0) / 100 in
  Video.fill ~on:cntx 
    ~rect:(Sdlvideo.rect x0 Constants.status_ammo_y a_len Constants.status_bar_height) 
    Constants.status_ammo_color;
  if status.Player.is_reloading && !frame < Constants.status_blinking_time then
    Font.draw_string ~on:cntx font_white x0 Constants.status_reloading_y 
      Constants.status_reloading_text;
  let lives_t = Constants.status_lives_text ^ string_of_int status.Player.lives in
  Font.draw_string ~on:cntx font_green x0 Constants.status_lives_y lives_t;
  let kills_t = Constants.status_kills_text ^ string_of_int status.Player.kills in
  Font.draw_string ~on:cntx font_green x0 Constants.status_kills_y kills_t
;;

