(** {6 Konstruktory plansz} *)

(** [Level.set_level number] plansza numer [number] staje si aktualn plansz,
    ycia=8, punkty=0 *)
val set_level : int -> unit;;

(** [Level.set_next_level ()] robocik przeszed do nastepnej planszy.
    Nast. plansza staje si aktualna, nie zmieniam iloci y i punktw *)
val set_next_level : unit -> unit;;

(** [print file_name] wypisuj obraz planszy do pliku [file_name] *)
val print : string -> unit;;


(** {6 Restart planszy} *)

(** [Level.next_level_exist ()] czy aktualna plansza jest ostatnia? *)
val next_level_exist : unit -> bool;;

(** [Level.restart_ok ()] czy mona restartowa, czy te stracie wszystkie 
    robociki? *)
val restart_ok : unit -> bool;;

(** [Level.restart ()] Odejmij jedno ycie i zacznij plansz od pocztku *)
val restart : unit -> unit;;

(** [Level.blow_all ()] wszystkie elementy !=Empty,Wall zamieniam w wybuchy *)
val blow_all : unit -> unit;;

(** [Level.remove_col col] wszystkie elementy z kolumny [col] zastpuj przez 
    Nothing *)
val remove_col : int -> unit;;


(** {6 Kroki gry} *)
type action = NOTHING|MOVE of Direction.t|FIRE of Direction.t;;

(** [Level.next_action] zrb co z plansz 
    Parametry tak czsto si zmieniaj, e skoda cokolwiek opisywa *)
val next_action : (unit -> action) -> unit;;


(** {6 Prezentacja graficzna planszy} *)
(** [Level.draw_image ()] Wyrysuj obraz planszy na odpowiednim kontekcie *)
val draw_image : unit -> unit;;

(** [Level.draw_info ?always ()] Wyrysuj informacje o planszy (punkty itp.)
    tylko jeli trzeba (domylnie) lub zawsze (always=true) *)
val draw_info : ?always:bool -> unit -> unit;;
